
#include <cstdio>
#include <cstdlib>

class Shape {
public:
    int x,y;

    void print(){
        printf("shape: x=%d,y=%d\n",x,y);
    }
};

class Circle : public Shape {
public:
    float r;
    void print(){
        printf("circle: x=%d,y=%d,r=%f\n",x,y,r);
    }    
};

class Rectangle : public Shape {
public:
    float w,h;      // width/height
    void print(){
        printf("rectangle: x=%d,y=%d,w=%f,h=%f\n",x,y,w,h);
    }        
};

int main(){
    Shape s;
    Circle c;
    Rectangle r;

    s.x = 3;
    s.y = 34;

    c.x = 323;
    c.y = 2;
    c.r = 234;

    r.x = 32;
    r.y = 32;
    r.w = 323;
    r.h = 23;

    r.print();
    s.print();
    printf("assignment: s = r;\n");
    s = r;

    r.print();
    s.print();
    
    // r = s;    // shape is not a rectangle.

    // create pointer to a circle;
    Circle* cp;
    cp = new Circle();  // create a new circle object.
    cp->x = 12;     // using -> instead of . due to pointer.
    (*cp).y = 34;   // deref, then can use dot.
    cp->r = 56;
    cp->print();

    Shape* sp;      // declare shape pointer.
    sp = cp;        // assign pointers.

    sp->print();    // what is called: circle or shape?
                    // ans: shape.
    
    Circle* cp2 = (Circle*)sp;  // make a circle pointer
                                // from shape pointer.

    cp2->print();       // circle print.

    delete cp;          // wipe out original object.

    //cp2->print();       // print out non-existant object.
                        // this may (and should) blow up.

    printf("Hello World!\n");

    return 0;
}


